<template>
  <div>
    <div class="container">
      <div class="container">
        <div class="row">
          <div class="col-md-12 col-lg-8">
            <div class="title-box-d">
              <br />
              <h1 class="title-d" style="text-align:left; font-size: 250%">Restaurant Categories</h1>
            </div>
          </div>
        </div>
      </div>
    </div>
    <div class="container">
      <div class="form-group row">
        <div class="col-md-12">
          <ListView
            :items="restaurantsCategories"
            :showColumnChooser="false"
            :editable="true"
            :hideSearch="true"
            :deleteable="true"
            :displayFormats="formats"
            :sortKey="Description"
            @onEdit="Edit"
            @onDelete="Delete"
            @onNew="New"
          />
        </div>
        <modal name="Category" :width="600" :height="600">
          <Category @CategoryUpdate="CategoryUpdate" :editCategory="CurrentCategory" />
        </modal>
      </div>
      <div v-if="wait" id="preloader"></div>
    </div>
  </div>
</template>

<script>
import Category from "../restaurants/restaurantCategory";
import ListView from "../shared/listView";
import { mapState, mapActions } from "vuex";

export default {
  name: "RestaurantCategoryList",
  components: {
    ListView,
    Category
  },
  data() {
    return {
      wait: true,
      formats: ["", "", "image"],
      category: {}
    };
  },
  methods: {
    ...mapActions("restaurantCategories", [
      "getCategories",
      "addCategory",
      "updateCategory",
      "deleteCategory"
    ]),
    New() {
      this.category = null;
      this.$modal.show("Category");
    },
    Edit(item) {
      this.category = item;
      this.$modal.show("Category");
    },
    Delete(item) {
      this.deleteCategory(item.id);
    },
    CategoryUpdate(item) {
      //Add new
      if (item.id == 0) {
        this.addCategory(item);
      } else {
        this.updateCategory(item);
      }
      this.$modal.hide("Category");
    }
  },
  computed: {
    ...mapState("restaurantCategories", ["restaurantsCategories"]),
    CurrentCategory() {
      return this.category;
    }
  },
  mounted() {
    this.getCategories().then(() => {
      this.wait = false;
    });
  }
};
</script>